// ======================================================================
// 
// dllmem.h
// jeff grills
//
// copyright 1997 origin systems inc
//
// ======================================================================

#ifndef DLLMEM_H
#define DLLMEM_H

// ======================================================================

void *operator new(size_t sz);
void *operator new(size_t sz, const char *file, u_int16 line);
void operator  delete(void *ptr);

#if USE_NEW_ARRAY
// prototypes for our overloaded new and delete array calls
void *operator new[](size_t sz);
void *operator new[](size_t sz, const char *file, u_int16 line);
void operator  delete[](void *ptr);
#endif

// ======================================================================

class MemoryManager
{
public:
	static u_int8 (*getFreePattern)(void);
	static u_int8 (*getUserPattern)(void);
	static u_int8 (*getGuardPattern)(void);
};

class DLLMemoryManager
{
public:

	static void  *(*alloc)(u_int sz, const char *file, int line, bool array);
	static void   (*free)(void *ptr, bool array);

};

// ======================================================================

template<class T> inline T *MemOwn(T *p, const char *fn, int line)
{
	UNREF(fn);
	UNREF(line);
	return p;
}

// ======================================================================

#define NEW new(__FILE__,__LINE__)
#define MEM_OWN(p) MemOwn(p, (const char *)__FILE__, __LINE__)

// ======================================================================

#endif
